/*********************************************************************NVMH3****
File:  $Id: SimplePS2.fx,v 1.1 2004/03/22 17:48:01 holger Exp $

Copyright NVIDIA Corporation 2002
TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, THIS SOFTWARE IS PROVIDED
*AS IS* AND NVIDIA AND ITS SUPPLIERS DISCLAIM ALL WARRANTIES, EITHER EXPRESS
OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT SHALL NVIDIA OR ITS SUPPLIERS
BE LIABLE FOR ANY SPECIAL, INCIDENTAL, INDIRECT, OR CONSEQUENTIAL DAMAGES
WHATSOEVER (INCLUDING, WITHOUT LIMITATION, DAMAGES FOR LOSS OF BUSINESS PROFITS,
BUSINESS INTERRUPTION, LOSS OF BUSINESS INFORMATION, OR ANY OTHER PECUNIARY LOSS)
ARISING OUT OF THE USE OF OR INABILITY TO USE THIS SOFTWARE, EVEN IF NVIDIA HAS
BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.


Comments:
	Tiny ps2 assembly example

******************************************************************************/

float4x4 WorldViewProj : WorldViewProjection < string UIWidget="None"; >;

texture diffuseTexture : DIFFUSE
<
	string ResourceName = "default_color.dds";
    string TextureType = "2D";
>;

technique SimplePS2 {
	pass p0 {
		VertexShaderConstant[0] = <WorldViewProj>;

		VertexShader = asm {
			vs_2_0
			dcl_position0 v0
			dcl_texcoord0 v7
			// Transform pos to screen space.
			m4x4 oPos, v0, c0
			mov oT0, v7
		};

		ZEnable = true;
		ZWriteEnable = true;
		CullMode = CW;
		Texture[0] = <diffuseTexture>;
		MinFilter[0] = Linear;
		MagFilter[0] = Linear;
		MipFilter[0] = Linear;

		PixelShader = asm {
			ps_2_0
			dcl t0.xy
			dcl_2d s0
			texld r0, t0, s0
			mov oC0, r0
		};
	}
}

/////////////////////// eof ///
