/*********************************************************************NVMH3****
File:  $Id: scene_cubeBg.fx,v 1.1 2004/03/22 17:48:02 holger Exp $

Copyright NVIDIA Corporation 2002
TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, THIS SOFTWARE IS PROVIDED
*AS IS* AND NVIDIA AND ITS SUPPLIERS DISCLAIM ALL WARRANTIES, EITHER EXPRESS
OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT SHALL NVIDIA OR ITS SUPPLIERS
BE LIABLE FOR ANY SPECIAL, INCIDENTAL, INDIRECT, OR CONSEQUENTIAL DAMAGES
WHATSOEVER (INCLUDING, WITHOUT LIMITATION, DAMAGES FOR LOSS OF BUSINESS PROFITS,
BUSINESS INTERRUPTION, LOSS OF BUSINESS INFORMATION, OR ANY OTHER PECUNIARY LOSS)
ARISING OUT OF THE USE OF OR INABILITY TO USE THIS SOFTWARE, EVEN IF NVIDIA HAS
BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.


Comments:
    Put a 3D texture *behind* the current scene

<scene_commands>
<setcolortarget/>
<clear color="0,0,0,0" depth="1.0"/>
<settechnique name="cube" />
<draw type="buffer"/>
<draw type="objects"/>
</scene_commands>
******************************************************************************/

///////// Textures ///////////////

texture BgTexture
<
    string ResourceName = "default_reflection.dds";
    string TextureType = "CUBE";
>;

samplerCUBE BgSampler = sampler_state
{
    Texture = <BgTexture>;
    MinFilter = Point;
    MagFilter = Point;
    MipFilter = Point;
	AddressU = CLAMP;
	AddressV = CLAMP;
	AddressW = CLAMP;
};

//////////////////////////////////////////

#include "Quad.fxh"

float4x4 WorldViewI : VIEWINVERSE;

//////////////////////////

struct CubeVertexOutput
{
   	float4 Position	: POSITION;
    float3 UV		: TEXCOORD0;
};

CubeVertexOutput CubeVS(
		float3 Position : POSITION, 
		float3 TexCoord : TEXCOORD0
) {
    CubeVertexOutput OUT;
	OUT.Position = float4(Position.xyz, 1);
    OUT.UV = mul(float4(Position.xyz,0),WorldViewI).xyz; 
	return OUT;
}


float4 CubePS(CubeVertexOutput IN) : COLOR
{   
	float4 texCol = texCUBE(BgSampler, IN.UV);
	return texCol;
}  

///////////////////////////////////

technique cube {
	pass p0 {
		VertexShader = compile vs_2_0 CubeVS();
		cullmode = none;
		ZEnable = false;
		PixelShader  = compile ps_2_0 CubePS();
	}
}

/***************************** eof ***/
