/*********************************************************************NVMH3****
File:  $Id: scene_displaceMap.fx,v 1.1 2004/03/22 17:48:02 holger Exp $

Copyright NVIDIA Corporation 2002
TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, THIS SOFTWARE IS PROVIDED
*AS IS* AND NVIDIA AND ITS SUPPLIERS DISCLAIM ALL WARRANTIES, EITHER EXPRESS
OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT SHALL NVIDIA OR ITS SUPPLIERS
BE LIABLE FOR ANY SPECIAL, INCIDENTAL, INDIRECT, OR CONSEQUENTIAL DAMAGES
WHATSOEVER (INCLUDING, WITHOUT LIMITATION, DAMAGES FOR LOSS OF BUSINESS PROFITS,
BUSINESS INTERRUPTION, LOSS OF BUSINESS INFORMATION, OR ANY OTHER PECUNIARY LOSS)
ARISING OUT OF THE USE OF OR INABILITY TO USE THIS SOFTWARE, EVEN IF NVIDIA HAS
BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.


Comments:
    Put a texture behind the current scene
	Geometry Ignored

<scene_commands>
<setcolortarget texture="ObjMap"/>
<clear color="0,0,0,0"/>
<draw type="objects"/>
<setcolortarget/>
<settechnique name="disp"/>
<draw type="buffer"/>
</scene_commands>
******************************************************************************/

#include "Quad.fxh"

QUAD_REAL Displacement <
	string UIWidget = "slider";
	QUAD_REAL UIMin = 0.0;
	QUAD_REAL UIMax = 1.0;
	QUAD_REAL UIStep = 0.001;
> = 0.01f;

///////// Textures ///////////////

texture DispTexture
<
	string UIName = "Displacement Texture";
    string ResourceName = "default_bump_normal.dds";
    string TextureType = "2D";
>;

sampler2D DispSampler = sampler_state
{
    Texture = <DispTexture>;
    MinFilter = Point;
    MagFilter = Point;
    MipFilter = None;
};

DECLARE_QUAD_TEX(ObjMap,ObjSampler,"A8R8G8B8")

QUAD_REAL4 dispPS(QuadVertexOutput IN) : COLOR
{   
	QUAD_REAL2 disp = Displacement*(((QUAD_REAL4)tex2D(DispSampler, IN.UV)).xy-(QUAD_REAL2)0.5);
	QUAD_REAL4 texCol = tex2D(ObjSampler, IN.UV+disp);
	return texCol;
}  

technique disp {
	pass TexturePass {
		VertexShader = compile vs_2_0 ScreenQuadVS();
		AlphaBlendEnable = false;
		ZEnable = false;
		PixelShader  = compile ps_2_a dispPS();
	}
}

/***************************** eof ***/
