<?xml version="1.0" encoding="UTF-8"?>
<!-- edited with XMLSPY v2004 rel. 3 U (http://www.xmlspy.com) by Chris Maughan (NVIDIA Corporation) -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xs="http://www.w3.org/2001/XMLSchema">
	<xsl:template match="/">
		<html>
			<head/>
			<body>
				<p>
					<p>
						<h2>FX Composer Semantics and Annotations</h2>
						The following lists known semantics and annotations from the Microsoft specification.  The 'Supported' column indicates values that FX Composer currently supports.  The 'FX Composer Only' column indicates additional semantics/annotations that are not part of the Microsoft specification, but are supported by FX Composer. 
						<br/>
						<h4>Note: All semantics and annotations are case insensitive</h4>
						<br/>
					</p>
				</p>
				<br></br>
				<h3>Semantics</h3>
				<br></br>
				<xsl:for-each select="fxmapping">
					<xsl:for-each select="semantics">
						<table border="1" cellpadding="4" bgcolor="#FFEEEE">
							<tbody>
								<tr>
									<td align="center">
										<h3>Semantic</h3>
									</td>
									<td align="center">
										<h3>Description</h3>
									</td>
									<td align="center">
										<h3>Data Type</h3>
									</td>
									<td align="center">
										<h3>Supported</h3>
									</td>
									<td align="center">
										<h3>FX Composer Only</h3>
									</td>
								</tr>
								<xsl:apply-templates select="semantic">
								</xsl:apply-templates>
							</tbody>
						</table>
					</xsl:for-each>
					<br></br>
					<h3>Annotations</h3>
					<br></br>
					<xsl:for-each select="annotations">
						<xsl:for-each select="annotationnames">
							<table border="1" cellpadding="4" bgcolor="#EEEEFF">
								<tbody>
									<tr>
										<td align="center">
											<h3>Annotation</h3>
										</td>
										<td align="center">
											<h3>Description</h3>
										</td>
										<td align="center">
											<h3>Data Type</h3>
										</td>
										<td align="center">
											<h3>Supported</h3>
										</td>
										<td align="center">
											<h3>FX Composer Only</h3>
										</td>
									</tr>
									<xsl:apply-templates select="annotationname">
									</xsl:apply-templates>
								</tbody>
							</table>
						</xsl:for-each>
					</xsl:for-each>
				</xsl:for-each>
				<br/>
			</body>
		</html>
	</xsl:template>
	<xsl:template match="semantic">
		<tr>
			<td align="left">
				<xsl:for-each select="@name">
					<xsl:value-of select="."/>
				</xsl:for-each>
				<xsl:choose>
					<xsl:when test="@indexed">#</xsl:when>
					<xsl:otherwise></xsl:otherwise>
				</xsl:choose>
			</td>
			<td align="left">
				<xsl:for-each select="@desc">
					<xsl:value-of select="."/>
				</xsl:for-each>
			</td>
			<td align="center">
				<xsl:for-each select="@datatypes">
					<xsl:value-of select="."/>
				</xsl:for-each>
			</td>
			<td align="center">
				<xsl:choose>
					<xsl:when test="@unsupported">-</xsl:when>
					<xsl:otherwise>yes</xsl:otherwise>
				</xsl:choose>
			</td>
			<td align="center">
				<xsl:choose>
					<xsl:when test="@fxcomposerspecific">yes</xsl:when>
					<xsl:otherwise>-</xsl:otherwise>
				</xsl:choose>
			</td>
		</tr>
	</xsl:template>
	<xsl:template match="annotationname">
		<tr>
			<td align="left">
				<xsl:for-each select="@name">
					<xsl:value-of select="."/>
				</xsl:for-each>
				<xsl:choose>
					<xsl:when test="@indexed">#</xsl:when>
					<xsl:otherwise></xsl:otherwise>
				</xsl:choose>
			</td>
			<td align="left">
				<xsl:for-each select="@desc">
					<xsl:value-of select="."/>
				</xsl:for-each>
			</td>
			<td align="center">
				<xsl:for-each select="@datatypes">
					<xsl:value-of select="."/>
				</xsl:for-each>
			</td>
			<td align="center">
				<xsl:choose>
					<xsl:when test="@unsupported">-</xsl:when>
					<xsl:otherwise>yes</xsl:otherwise>
				</xsl:choose>
			</td>
			<td align="center">
				<xsl:choose>
					<xsl:when test="@fxcomposerspecific">yes</xsl:when>
					<xsl:otherwise>-</xsl:otherwise>
				</xsl:choose>
			</td>
		</tr>
	</xsl:template>

</xsl:stylesheet>
