//-----------------------------------------------------//
//                                                     //
//            Code generated by RT/shader              //
//            at: 11.03.2004 17:57:36                  //
//                                                     //
//-----------------------------------------------------//


// Structures
struct simpleLighting_0_VS_OUT {
	float4 pos : POSITION;
	float2 texCoord : TEXCOORD0;
};

struct simpleLighting_0_PS_OUT {
	float4 col : COLOR0;
};


// Uniform Parameters
float4x4 projTM : WorldViewProjection;
float4x4 worldTM : World;
float4 lightPos : WorldLightPosition;
float4 eyePos : WorldEyePosition;
texture diffuseTexture1;

// Samplers
sampler2D diffuseTexture1Sampler = sampler_state
{
	Texture = <diffuseTexture1>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
};


// Functions
float2 AnisotropicLighting(
		float4 surfPos,
		float3 surfNorm,
		float4 lightPos,
		float4 eyePos)
{
	float3 lv = normalize(lightPos.xyz-surfPos);
	float3 ev = normalize(eyePos.xyz-surfPos);
	float3 hv = normalize(lv+ev);
	return float2(dot(lv, surfNorm), dot(hv, surfNorm));
}

simpleLighting_0_VS_OUT simpleLighting_0_VS(
		float3 pos : POSITION,
		float3 norm : NORMAL,
		uniform float4x4 projTM,
		uniform float4x4 worldTM,
		uniform float4 lightPos,
		uniform float4 eyePos)
{
	simpleLighting_0_VS_OUT OUT;
	OUT.pos = mul(float4(pos.xyz, 1), projTM);
	float4 surfPos = mul(float4(pos.xyz, 1), worldTM);
	float3 surfNorm = mul(norm, (float3x3)worldTM);
	OUT.texCoord = AnisotropicLighting(surfPos, surfNorm, lightPos, eyePos);
	return OUT;
}

simpleLighting_0_PS_OUT simpleLighting_0_PS(
		float2 texCoord : TEXCOORD0,
		uniform sampler2D diffuseTexture1Sampler)
{
	simpleLighting_0_PS_OUT OUT;
	float a = 2;
	float4 vect = tex2D(diffuseTexture1Sampler, texCoord.xy);
	float a1 = vect.w;
	float4 b = a1*vect;
	OUT.col = a*b;
	return OUT;
}


// Techniques
technique T0
{
	pass P0
	{
		VertexShader = compile vs_2_0 simpleLighting_0_VS(projTM, worldTM, lightPos, eyePos);
		PixelShader = compile ps_2_0 simpleLighting_0_PS(diffuseTexture1Sampler);
		AddressU[0] = Clamp;
		AddressV[0] = Clamp;
	}
}

