//-----------------------------------------------------//
//                                                     //
//            Code generated by RT/shader              //
//            at: 11.03.2004 17:56:27                  //
//                                                     //
//-----------------------------------------------------//


// Structures
struct Technique1_Pass1_VS_OUT {
    float4 position : POSITION;
    float2 uv0 : TEXCOORD0;
    float3 reflectVector : TEXCOORD1;
};

struct Technique1_Pass1_PS_OUT {
    float4 color : COLOR0;
};


// Uniform Parameters
float4x4 projTM : WorldViewProjection;
float4x4 worldTM : World;
float4 eyePos : WorldEyePosition;
texture Texture;
textureCUBE Reflection;

// Samplers
sampler2D TextureSampler = sampler_state
{
    Texture = <Texture>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = LINEAR;
};

samplerCUBE ReflectionSampler = sampler_state
{
    Texture = <Reflection>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = LINEAR;
};


// Functions
Technique1_Pass1_VS_OUT Technique1_Pass1_VS(
        float3 pos : POSITION,
        float2 uv0 : TEXCOORD0,
        float3 norm : NORMAL,
        uniform float4x4 projTM,
        uniform float4x4 worldTM,
        uniform float4 eyePos)
{
    Technique1_Pass1_VS_OUT OUT;
    OUT.position = mul(float4(pos.xyz, 1), projTM);
    OUT.uv0 = uv0;
    float4 surfPos1 = mul(float4(pos.xyz, 1), worldTM);
    float3 surfNorm1 = mul(norm, (float3x3)worldTM);
    OUT.reflectVector = reflect(normalize(surfPos1-eyePos), surfNorm1).xyz;
    return OUT;
}

Technique1_Pass1_PS_OUT Technique1_Pass1_PS(
        float2 uv0 : TEXCOORD0,
        float3 reflectVector : TEXCOORD1,
        uniform sampler2D TextureSampler,
        uniform samplerCUBE ReflectionSampler)
{
    Technique1_Pass1_PS_OUT OUT;
    float4 a1 = tex2D(TextureSampler, uv0.xy);
    float4 a2 = texCUBE(ReflectionSampler, reflectVector.xyz);
    float val1 = a1.w;
    float b1 = 1-val1;
    float4 a3 = a2*b1;
    float4 b2 = a3*1.71239674091339f;
    float4 col1 = a1*b2;
    OUT.color = float4(col1.x, col1.y, col1.z, val1);
    return OUT;
}


// Techniques
technique Technique1
{
    pass Pass1
    {
        VertexShader = compile vs_2_0 Technique1_Pass1_VS(projTM, worldTM, eyePos);
        PixelShader = compile ps_2_0 Technique1_Pass1_PS(TextureSampler, ReflectionSampler);
        AlphaBlendEnable = true;
        SrcBlend = SRCALPHA;
        DestBlend = INVSRCALPHA;
        ZWriteEnable = false;
        CullMode = CW;
    }
}

